Woopsi 1.0 GUI Framework for Nintendo DS Homebrew

- Main Page
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Static Public Member Functions

# WoopsiUI::Debug Class Reference

`#include <debug.h>`

List of all members.

## Static Public Member Functions
static void | busyWait ()
static void | printf (const char *format,...)
static void | wvsnprintf (size_t maxCount, const char *format, va_list args)
static void | flipToTopScreen ()
static void | flipToBottomScreen ()
static void | flipScreens ()
static void | raiseToTop ()
static void | lowerToBottom ()

## Detailed Description

Debugging console. The class automatically creates its own screen and full GUI when one of the output routines is called.

The DEBUG_ACTIVE define must be set to "true" for the debugger to work. If this is defined as "false", calls to the debugger will silently be ignored.

## Member Function Documentation

static void WoopsiUI::Debug::busyWait | ( |  | ) | `[static]`

Freeze program until the B button is pressed.

static void WoopsiUI::Debug::flipScreens | ( |  | ) | `[static]`

Flip the screen from the current physical display to the other.

static void WoopsiUI::Debug::flipToBottomScreen | ( |  | ) | `[static]`

Flip the screen from the top physical display to the bottom display.

static void WoopsiUI::Debug::flipToTopScreen | ( |  | ) | `[static]`

Flip the screen from the bottom physical display to the top display.

static void WoopsiUI::Debug::lowerToBottom | ( |  | ) | `[static]`

Lowers the gadget to the bottom of its parent's gadget stack.

Returns:
  True if the lower was successful.

static void WoopsiUI::Debug::printf | ( | const char * | format,
|  |  | ...
| ) |  | `[static]`

Output formatted values to the debug console. Uses standard printf() syntax.

Parameters:

  format | Format of the string to print.
  ... | The values to output.

static void WoopsiUI::Debug::raiseToTop | ( |  | ) | `[static]`

Raises the gadget to the top of its parent's gadget stack.

Returns:
  True if the raise was successful.

static void WoopsiUI::Debug::wvsnprintf | ( | size_t | maxCount,
|  | const char * | format,
|  | va_list | args
| ) |  | `[static]`

Output formatted values to the debug console. Uses standard printf() syntax. Note that va_start() must be called before this method is used, and va_end() must be called when it finishes.

The method uses vsnprintf() internally to perform the string formatting. Unfortunately, this means that the method cannot be called vsnprintf() itself as it hides the original C method. Hence, this method's name is prefixed with a "w" (for "Woopsi".

Note that the compiler message regarding va_list mangling changes in GCC 4.4 are not problems with Woopsi's code. They are the result of the GCC team bizarrely deciding to include news items in compiler messages: http://gcc.gnu.org/bugzilla/show_bug.cgi?id=42748

Parameters:

  maxCount | The maximum number of characters to print.
  format | Format of the string to print.
  args | The values to output.

The documentation for this class was generated from the following file:

- debug.h